import java.io.*;
import org.chocosolver.solver.*;
import org.chocosolver.solver.variables.*;
import org.chocosolver.solver.search.strategy.*;
import org.chocosolver.solver.search.strategy.strategy.IntStrategy;

public class DecisionProblem {    
  
  public static void main(String[] args) throws FileNotFoundException, IOException {
      int dueDate           = Integer.parseInt(args[1]);  
      JSSP jssp             = new JSSP(args[0],dueDate);
      Solver solver         = jssp.model.getSolver();
      Decision[] decisions  = jssp.getDecisions();
      int n                 = decisions.length;
      IntVar makeSpan       = jssp.getMakeSpan();

      solver.setSearch(Search.inputOrderUBSearch(jssp.getDecisionIntVars()));

      System.out.println("solved: " + solver.solve());   

      System.out.println(makeSpan + " ["+ makeSpan.getLB() +","+ makeSpan.getUB() +"]");
      System.out.println("nodes: " + solver.getMeasures().getNodeCount() + 
                         "  cpu: " + solver.getMeasures().getTimeCount());
  }
}
//
// is there a legal schedule with a make span of dueDate, or less?
//
