import java.util.ArrayList;
import org.chocosolver.solver.Model;

public class Job {
    String id;
    ArrayList<Operation> operations;
    int length;
    Model model;
    
    Job(String id,Model model){
	this.id    = id;
	operations = new ArrayList<Operation>();
	length     = 0;
	this.model = model;
    }
    
    void add(Operation op){
	if (!operations.isEmpty()) operations.get(length-1).before(op).post();
	operations.add(op);
	length++;
    }
    //
    // adding operations in sequence to a job, such that
    // operation op_i is before operation op_i+1 
    // i.e. precedence constraints between operations in a job.
    //

    Operation get(int i){return operations.get(i);}
    
    public String toString(){
	String s = "(" + id + " ";
	for (int i=0;i<operations.size();i++) s = s + ((Operation)operations.get(i)).toString() + " ";
	return s + ")";
    }
}
