import org.chocosolver.solver.Model;
import org.chocosolver.solver.variables.IntVar;
import org.chocosolver.solver.constraints.Constraint;

public class Operation {
    String id;
    String resId;
    int duration;
    IntVar start;
    Model model;

    Operation(String id,String resId,int duration,int earliestStart,int latestStart,Model model){
	this.id       = id;
	this.resId    = resId;  // resource id
	this.duration = duration;
	this.model    = model;
	start         = model.intVar(id,earliestStart,latestStart);
    }
    
    public String toString(){ 
	return "{" + id + " " + resId + " " + duration + " [" + start.getLB() + "," + start.getUB() + "]}";
    }
    
    Constraint before(Operation op2){
	return model.arithm(op2.start,">=",start,"+",duration);
    }
    //
    // this operation is before operation op2
    // Therefore, if this operation starts at time t and has duration d
    // it finishes at time t+d. Therefore operation op2 can start immediately
    // at time t+d or any time after that
    //
}
